VERSION 5.00
Begin VB.Form Form1 
   BackColor       =   &H00000000&
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Form1"
   ClientHeight    =   5550
   ClientLeft      =   3945
   ClientTop       =   1830
   ClientWidth     =   7320
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   370
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   488
   ShowInTaskbar   =   0   'False
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'-------------------------------------------
'  Break Out  Example / Casse brique Exemple
'-----------------------------------------
'
' CDVJ - http://francis.dupont.free.fr/coindev/
' CDVG - http://francis.dupont.free.fr/coindev/english/
'


' v.05
' Initial release


Public Directx As New DirectX7  'DirectX main object
Public DD As DirectDraw7        'DirectDraw for creating surface
Public Primary As DirectDrawSurface7  'represents the screen
Public BackBuffer As DirectDrawSurface7 'is a block of memory which will be flipped in the primary surface

Public PaletteT As DirectDrawSurface7 ' not a image palette (256colors)!
Private Bricks(4) As DirectDrawSurface7
Public ball As DirectDrawSurface7

Private Type Brick
  PositionX As Long
  PositionY As Long
  State As Integer  '0 for destroyed, 1 for not destroyed
  Width As Long
  Height As Long
  Brickrect As RECT
End Type

Private Br(2000) As Brick

Public PaletteX, NbBricks, Score, TimeElapsed


Public MouseX, MouseY, MouseB

Private Type BallType
  PositionX As Single
  PositionY As Single
  SpeedX As Single
  SpeedY As Single
  Style As Integer
  Active As Boolean
  BallRect As RECT
End Type

Private Balls(10) As BallType

'for collision detection
Private Declare Function IntersectRect Lib "user32" (lpDestRect As RECT, lpSrc1Rect As RECT, lpSrc2Rect As RECT) As Long

'avoid seeing mouse cursor
Private Declare Function ShowCursor Lib "user32" (ByVal bShow As Long) As Long

Sub CheckBound(ball)
Dim IntX As Single, IntY As Single
 With Balls(ball)
  .BallRect = REC(.PositionX, .PositionY, .PositionX + 10, .PositionY + 10)
 End With
 
 'check collision with palette / vrifie la collision avec la palette
 Dim PaletteRect As RECT
 PaletteRect = REC(PaletteX, 400, PaletteX + 80, 420)
 
 coll = CheckCollision(PaletteRect, Balls(ball).BallRect, IntX, IntY)
 If coll > 0 Then
  Balls(ball).SpeedY = -Balls(ball).SpeedY
  Balls(ball).SpeedX = Balls(ball).SpeedX + (-40 + IntX) / 40

 leng = Sqr(Balls(ball).SpeedX ^ 2 + Balls(ball).SpeedY ^ 2)
 Balls(ball).SpeedX = Balls(ball).SpeedX / leng * 4
 Balls(ball).SpeedY = Balls(ball).SpeedY / leng * 4
 
 End If
 
 'check if the ball is too  ----------> <---------- ----------> (hum..)
 If Abs(Balls(ball).SpeedX) > Abs(Balls(ball).SpeedY * 2) Then
   d = Sgn(Balls(ball).SpeedX)
   e = Sgn(Balls(ball).SpeedY)
   Balls(ball).SpeedX = Balls(ball).SpeedY * 2 * d * e
   
 End If


 If Balls(ball).PositionY < 5 Then Balls(ball).SpeedY = -Balls(ball).SpeedY
 If Balls(ball).PositionX < 5 Then Balls(ball).SpeedX = -Balls(ball).SpeedX
 If Balls(ball).PositionX > 635 Then Balls(ball).SpeedX = -Balls(ball).SpeedX
 If Balls(ball).PositionY > 440 Then
  'check if a ball is still active / vrifie si une balle est encore active
  Balls(ball).Active = False
  bal = 0
  For i = 1 To 10
   If Balls(i).Active = True Then
    bal = bal + 1
   End If
  Next i
  If bal = 0 Then
   MouseB = 0
    
    Do
     BackBuffer.BltColorFill REC(0, 0, 0, 0), 0
     BackBuffer.SetForeColor RGB(0, 256, 0)
     Form1.FontName = "Arial"
     Form1.FontSize = 30
     BackBuffer.SetFont Form1.Font
     BackBuffer.DrawText 10, 60, "GAME OVER !", False
     
     Form1.FontSize = 12
     BackBuffer.SetFont Form1.Font
     BackBuffer.DrawText 60, 290, "Click to try again !", False
     BackBuffer.DrawText 60, 320, "Cliquer pour ressayer !", False
     
     Primary.Flip Nothing, DDFLIP_WAIT
     DoEvents
     
    Loop Until MouseB = 1
    Game
    
  End If
 End If

 
 'Check each other balls/ vrifie chaque autre balle
 For i = 1 To 10
  If ball <> i And Balls(i).Active Then
    Balls(i).BallRect = REC(Balls(i).PositionX, Balls(i).PositionY, Balls(i).PositionX + 10, Balls(i).PositionY + 10)
    coll = CheckCollision(Balls(i).BallRect, Balls(ball).BallRect, IntX, IntY)
    If coll > 0 Then
     Balls(ball).SpeedX = -Balls(ball).SpeedX
     Balls(ball).SpeedY = -Balls(ball).SpeedY
     Balls(i).SpeedX = -Balls(i).SpeedX
     Balls(i).SpeedY = -Balls(i).SpeedY
    End If
  End If
 Next i
 
 
 'Check each brick
 For i = 1 To NbBricks
   With Br(i)
    If Br(i).State = 1 Then
      .Brickrect = REC(.PositionX, .PositionY, .PositionX + .Width, .PositionY + .Height)
      coll = CheckCollision(.Brickrect, Balls(ball).BallRect, IntX, IntY)
      If coll > 0 Then
       Br(i).State = 0
       Score = Score + 100
       'change the ball speed
       'if the ball has just hit the bottom of the brick
       BackBuffer.SetForeColor RGB(0, 256, 0)
       BackBuffer.DrawText 100, 100, CStr(IntX) + " " + CStr(IntY), False
       If IntY < 2 And IntX > 3 And IntX < 37 Then
          Balls(ball).SpeedY = -Balls(ball).SpeedY
       End If
       If IntY > 8 And IntX > 3 And IntX < 37 Then
        Balls(ball).SpeedY = -Balls(ball).SpeedY
       End If
       If IntX < 3 And IntY > 2 And IntY < 8 Then
         Balls(ball).SpeedX = -Balls(ball).SpeedX
       End If
       If IntX > 37 And IntY > 2 And IntY < 8 Then
        Balls(ball).SpeedX = -Balls(ball).SpeedX
       End If
      End If
    End If
   End With
   
 Next i
End Sub

Function CheckCollision(re1 As RECT, re2 As RECT, IntersectX As Single, IntersectY As Single) As Long
  Dim TempRect As RECT
  CheckCollision = IntersectRect(TempRect, re1, re2)
  If CheckCollision > 0 Then
    IntersectX = (TempRect.Right + TempRect.Left) / 2 - re1.Left
    IntersectY = (TempRect.Bottom + TempRect.Top) / 2 - re1.Top
    'Debug.Print IntersectX, IntersectY, TempRect.Left, TempRect.Top, TempRect.Right, TempRect.Bottom
  End If
End Function


Sub DrawAll()
 
 'Draw bricks
 For i = 1 To NbBricks
   If Br(i).State > 0 Then
   BackBuffer.BltFast Br(i).PositionX, Br(i).PositionY, Bricks(1), REC(0, 0, 0, 0), DDBLTFAST_WAIT
   End If
  Next i
  
  'Draw balls
  For i = 1 To 10
   If Balls(i).Active = True Then
     BackBuffer.BltFast Balls(i).PositionX, Balls(i).PositionY, ball, REC(0, 0, 0, 0), DDBLTFAST_WAIT
   End If
  Next i
  
  'Draw "palette"
  BackBuffer.BltFast PaletteX, 400, PaletteT, REC(0, 0, 0, 0), DDBLTFAST_WAIT
  
  'Write score
  BackBuffer.SetForeColor RGB(256, 256, 0)
  BackBuffer.DrawText 0, 430, "Score : " + CStr(Score), False
  
End Sub

Sub Game()

 Randomize Timer
 'init all the balls
 For i = 1 To 10
 With Balls(i)
  .Active = True
  .PositionX = 640 * Rnd
  .PositionY = 150 * Rnd
  
  'set and normalize ball speed
  .SpeedX = Rnd * 2 - 1
  .SpeedY = -Rnd
  leng = Sqr(.SpeedX ^ 2 + .SpeedY ^ 2)
  .SpeedX = .SpeedX / leng * 4
  .SpeedY = .SpeedY / leng * 4
 End With
 Next i
 
 NbBricks = 0
   'Create a bricks zone / Cre une zone de briques
  For X = 1 To 15
   For Y = 1 To 20
     NbBricks = NbBricks + 1
     
     With Br(NbBricks)
      .PositionX = X * 40 - 30
      .PositionY = Y * 10 - 20
      .Width = 40
      .Height = 10
      .State = 1
     End With
   Next Y
  Next X
   
 'main loop
 oldtime = Directx.TickCount
 Do
  TimeElapsed = Directx.TickCount - oldtime
  oldtime = Directx.TickCount
  
  BackBuffer.BltColorFill REC(0, 0, 0, 0), 0
  DrawAll
  MoveAll
  
  Primary.Flip Nothing, DDFLIP_WAIT
  DoEvents
  
 Loop
 
End Sub
Sub InitGame()
 
  'hide the mouse cursor
  ShowCursor 0
 
 'Initialize DirectDraw / Initialise DirectDraw
  Set DD = Directx.DirectDrawCreate("")
  DD.SetCooperativeLevel Form1.hWnd, DDSCL_EXCLUSIVE Or DDSCL_FULLSCREEN Or DDSCL_ALLOWREBOOT
  
  'Set the video mode 640x480x16 / Met un mode vido : 640x480x16
  DD.SetDisplayMode 640, 480, 16, 0, DDSDM_DEFAULT
  
  'Create Primary Surface / Cre la surface primaire
  
  Dim ddsd As DDSURFACEDESC2
  ddsd.lFlags = DDSD_CAPS Or DDSD_BACKBUFFERCOUNT
  ddsd.ddscaps.lCaps = DDSCAPS_COMPLEX Or DDSCAPS_FLIP Or DDSCAPS_PRIMARYSURFACE
  ddsd.lBackBufferCount = 1
  Set Primary = DD.CreateSurface(ddsd)
  
  'Get the backbuffer / Obtient le BackBuffer
  Dim ddscaps As DDSCAPS2
  ddscaps.lCaps = DDSCAPS_BACKBUFFER
  Set BackBuffer = Primary.GetAttachedSurface(ddscaps)
  
  'Load  bitmaps / Charge les images
  Dim ddsd2 As DDSURFACEDESC2
  Set ball = DD.CreateSurfaceFromFile(App.Path + "\bo2.bmp", ddsd2)
  Dim ddsd3 As DDSURFACEDESC2
  Set Bricks(1) = DD.CreateSurfaceFromFile(App.Path + "\bo1.bmp", ddsd3)
  Dim ddsd4 As DDSURFACEDESC2
  Set PaletteT = DD.CreateSurfaceFromFile(App.Path + "\bo3.bmp", ddsd4)
  
End Sub

Sub MoveAll()
  
  ' Mouse stuff
  If MouseX < 640 - 80 Then
   PaletteX = MouseX
  Else
   PaletteX = 640 - 80
  End If
  
  'Balls stuff
  For i = 1 To 10
   With Balls(i)
    If .Active = True Then
       .PositionX = .PositionX + .SpeedX * TimeElapsed / 30
       .PositionY = .PositionY + .SpeedY * TimeElapsed / 30
       CheckBound i
    End If
   End With
  Next i
  
  
End Sub

Function REC(X, Y, x1, y1) As RECT
 REC.Left = X
 REC.Right = x1
 REC.Bottom = y1
 REC.Top = Y
End Function


Sub UnloadGame()
 Set Primary = Nothing
 Set ball = Nothing
 Set BackBuffer = Nothing
 Set DD = Nothing
 Set PaletteT = Nothing
 Set Directx = Nothing
 
 ShowCursor 1
 End
 
End Sub

Private Sub Form_KeyPress(KeyAscii As Integer)
  If KeyAscii = 27 Then UnloadGame
End Sub

Private Sub Form_Load()
 InitGame
 Game
End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
   MouseX = X
   MouseY = Y
   MouseB = Button
End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
   MouseX = X
   MouseY = Y
   MouseB = Button
End Sub


Private Sub Form_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
   MouseX = X
   MouseY = Y
   MouseB = Button
End Sub


Private Sub Form_Unload(Cancel As Integer)
 UnloadGame
End Sub


